package jp.sourceforge.shovel.entity;

import java.util.TimeZone;

import jp.sourceforge.shovel.RepliesType;
import jp.sourceforge.shovel.exception.ApplicationException;

public interface IUser {
    boolean isAdministrator();
    void setAdministrator(boolean administrator);
    long getCreatedTime();
    void setCreatedTime(long createdTime);
    long getCreatorId();
    void setCreatorId(long creatorId);
    String getDescription();
    void setDescription(String description);
    int getDirectMessages();
    void setDirectMessages(int directMessages);
    String getDisplayName();
    void setDisplayName(String displayName);
    String getEmail();
    void setEmail(String email);
    int getFavorites();
    void setFavorites(int favorites);
    String getForeignKey();
    void setForeignKey(String foreignKey);
    String getLocation();
    void setLocation(String location);
    long getModifiedTime();
    void setModifiedTime(long modifiedTime);
    long getModifierId();
    void setModifierId(long modifierId);
    String getPassword();
    void setPassword(String password);
    boolean isRemoved();
    void setRemoved(boolean removed);
    long getServerFileId();
    void setServerFileId(long serverFileId);
    String getTimeZoneId();
    void setTimeZoneId(String tzId);
    long getUserId();
    void setUserId(long userId);
    int getViewLines();
    void setViewLines(int viewLines);
    //TODO バージョンアップが可能になったらスキーマもろともfriendsに
    int getFollowing();
    void setFollowing(int following);
    int getFollowers();
    void setFollowers(int followers);
    int getStatuses();
    void setStatuses(int statuses);
    boolean isRemove();
    void setRemove(boolean remove);
    int getReplies();
    void setReplies(int replies);
    RepliesType getRepliesType();
    void setRepliesType(RepliesType repliesType);
    int getGivenFavorites();
    void setGivenFavorites(int givenFavorites);
    
    /////
    
    String getCharset();
    void setCharset(String charset);
    String getMime();
    void setMime(String mime);
    String getName();
    void setName(String name);
    int getSize();
    void setSize(int size);
    int getWidth();
    void setWidth(int width);
    int getHeight();
    void setHeight(int height);
    long getServerFileCreatedTime();
    void setServerFileCreatedTime(long createdTime);
    
    /////
    
    String getAddress();
    void setAddress(String address);
    int getAvailability();
    void setAvailability(int availability);
    long getDeviceId();
    void setDeviceId(long deviceId);
    int getType();
    void setType(int type);
    
    /////
    
    String getBody();
    void setBody(String body);
    
    /////
    
    TimeZone getTimeZone();
    void setTimeZone(TimeZone timeZone);
    IServerFile getServerFile();
    void setServerFile(IServerFile serverFile);
    IDevice getDevice();
    void setDevice(IDevice device);
    String getReleaseKey() throws ApplicationException;
}
