<#macro exportUser user status="">
  <#local common=JspTaglibs["/WEB-INF/tld/common.tld"] />
  <#import "/macro.ftl" as macro />
{<#t />
  "id":${user.userId},<#t />
  "name":"<@common.ncrEncode data=user.displayName escape="json" />",<#t />
<#if user.location?has_content>
  "location":"<@common.ncrEncode data=user.location escape="json" />,<#t />
<#else>
  "location":null,<#t />
</#if>
<#if user.description?has_content>
  "description":"<@common.ncrEncode data=user.description escape="json" />,<#t />
<#else>
  "description":null,<#t />
</#if>
  "profile_image_url":"<@macro.userThumbnailUrl user=user />",<#t />
  "given_favorites_count":${user.givenFavorites},<#t />
  "friends_count":${user.following},<#t />
  "followers_count":${user.followers},<#t />
  "favourites_count":${user.favorites},<#t />
  "statuses_count":${user.statuses},<#t />
<#if status?has_content>
  "status":{<#t />
    "created_at":"<@common.dateFormat date=status.sentTime format="dateTime.compatible.twitter" timeZoneID="UTC" lang="en" />",<#t />
    "id":${status.statusId},<#t />
    "text":"<@common.ncrEncode data=status.body escape="json" />"<#t />
  }<#t />
<#else>
  "status":null<#t />
</#if>
}<#t />
</#macro>
<#if user?has_content>
  <@exportUser user=user status=status /><#t />
<#elseif users?has_content>
{<#t />
  <#list users as user>
    <#assign status=statuses[user.userId?string]?defualt("") />
    <@exportUser user=user status=status /><#t />
  </#list>
}<#t />
<#else>
{}<#t />
</#if>
