<#assign common=JspTaglibs["/WEB-INF/tld/common.tld"] />
<#assign core=JspTaglibs["http://java.sun.com/jsp/jstl/core"] />
<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#import "/macro.ftl" as macro />
<input type="hidden" name="csrf_ticket" value="${csrf_ticket?default('')}" />
<input type="hidden" name="source" value="web" />
<table class="timeline" cellspacing="0" cellpadding="0">
  <colgroup>
    <col />
    <col />
    <col align="right" width="25px" />
  </colgroup>
  <tbody>
<#if statuses?has_content && statuses?size &gt; 0>
  <#if Session.listRefine.viewType.publicTimeline>
    <tr class="announcement">
      <td colspan="3"><div class="badgebox">しゃべるで誰かが話しているよ！</div></td>
    </tr>
  </#if>
  <#list statuses as status>
    <#assign sender=status.sender />
    <#assign url><@html.rewrite page="/${sender.foreignKey}/statuses/${status.statusId}" /></#assign>
    <tr class="<#if status_has_next>status<#else>last-status</#if>">
      <td class="thumb">
    <@macro.icon page="/${sender.foreignKey}" user=sender size="large" />
      </td>
      <td class="content"><#rt />
        <strong style="font-weight: bolder;"><#t />
          <a href="<@html.rewrite page="/${sender.foreignKey}" />" ><span title="${sender.displayName}" id="home_foreignKey_${status.statusId}">${sender.foreignKey}</span></a><#t />
        </strong>&nbsp;<#t />
        <span id="<#if Session.listRefine.viewType.withFriends>people<#else>home</#if>_status_${status.statusId}" style="word-break: break-all;"><@common.autoFormat data=status.body url=url /></span>&nbsp;<#t />
        <span><#t />
          <a href="${url}"><#t />
    <@common.dateFormat date=status.sentTime format="dateTime.compact.variable" /><#t />
          </a><#t />
          &nbsp;from&nbsp;<@macro.sourceWithLink source=status.source dedicatedClient=status.dedicatedClient />&nbsp;<#t />
    <#if status.referenceId &gt; 0>
      <#assign referenceSender=status.referenceSender?default("") />
          <a href="<@html.rewrite page="/${referenceSender.foreignKey}/statuses/${status.referenceId}" />"><#t />
            in reply to ${referenceSender.foreignKey}<#t />
          </a><#t />
    </#if>
        </span><#t />
      </td><#lt />
      <td style="border-bottom: 1px solid #bbbbbb; padding: 7px 0pt;"><#rt />
    <#if login?has_content>
      <#assign favorite=status.favorite?default("") />
        <span id="<#if Session.listRefine.viewType.withFriends>people<#else>home</#if>_favorite_${status.statusId}"><#t />
      <#if favorite?has_content>
          <a href="#" onclick="return shovel.controller.unsetFavorite(${status.statusId});"><#t />
            <img src="<@html.rewrite href="${webroot}/image/star_full.gif" />" /><#t />
          </a><#t />
      <#else>
          <a href="#" onclick="return shovel.controller.setFavorite(${status.statusId});"><#t />
            <img src="<@html.rewrite href="${webroot}/image/star_empty.gif" />" /><#t />
          </a><#t />
      </#if>
        </span><#t />
      <#if login == sender.foreignKey>
        <a href="#" onclick="return shovel.controller.destroyStatus(${status.statusId});"><#t />
          <img src="<@html.rewrite href="${webroot}/image/trash.gif" />" /><#t />
        </a><#t />
      </#if>
      <#if !Session.listRefine.viewType.withFriends && !Session.listRefine.viewType.favorites>
        <a href="#" onclick="return shovel.controller.replyStatus(${status.statusId});"><#t />
          <img src="<@html.rewrite href="${webroot}/image/reply.gif" />" /><#t />
        </a><#t />
      </#if>
    <#else>
    &nbsp;
    </#if>
      </td><#lt />
    </tr>
  </#list>
<#else>
    <tr class="nocontent">
      <td colspan="3" class="nocontent">投稿はありません。</td>
    </tr>
</#if>
  </tbody>
<#assign left>
<#if Session.listRefine.viewType.recent || Session.listRefine.viewType.friendsTimeline>
<a href="<@html.rewrite page="/statuses/friends_timeline/${user.userId}.rss" />" style="float: left; padding: 4px 15px; border: 1px solid #cecece;">RSS</a>
<#elseif Session.listRefine.viewType.publicTimeline>
<a href="<@html.rewrite page="/statuses/public_timeline.rss" />" style="float: left; padding: 4px 15px; border: 1px solid #cecece;">RSS</a>
</#if>
</#assign>
<@macro.pager nextPage=nextPage left=left />
</table>
