<#assign common=JspTaglibs["/WEB-INF/tld/common.tld"]/>
<#assign core=JspTaglibs["http://java.sun.com/jsp/jstl/core"] />
<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#import "/macro.ftl" as macro />
<input type="hidden" name="csrf_ticket" value="${csrf_ticket?default('')}" />
<table class="timeline" cellspacing="0" cellpadding="0">
  <colgroup>
    <col />
    <col align="right" width="26px" />
  </colgroup>
  <tbody>
<#if statuses?has_content && statuses?size &gt; 0>
  <#list statuses as status>
    <#assign sender=status.sender />
    <#assign url="/${sender.foreignKey}/statuses/${status.statusId}" />
    <tr class="<#if status_has_next>status<#else>last-status</#if>">
      <td class="content">
        <span id="people_status_${status.statusId}">
          <@common.autoFormat data=status.body url=url />
        </span>
        <span>
          <a href="<@html.rewrite page=url />">
    <@common.dateFormat date=status.sentTime format="dateTime.compact.variable" />
          </a>
          from&nbsp;<@macro.sourceWithLink source=status.source dedicatedClient=status.dedicatedClient />
    <#if status.referenceId &gt; 0>
      <#assign referenceSender=status.referenceSender?default("") />
          <a href="<@html.rewrite page="/${referenceSender.foreignKey}/statuses/${status.referenceId}" />">
            in reply to ${referenceSender.foreignKey}
          </a>
    </#if>
        </span>
      </td><#lt />
      <td style="padding: 7px 3px; vertical-align: middle; border-bottom: 1px solid #bbbbbb;"><#rt />
    <#if login?has_content>
      <#assign favorite=status.favorite?default("") />
          <span id="people_favorite_${status.statusId}"><#t />
      <#if favorite?has_content>
            <a href="#" onclick="return shovel.controller.unsetFavorite(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/star_full.gif" />" /><#t />
            </a><#t />
      <#else>
            <a href="#" onclick="return shovel.controller.setFavorite(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/star_empty.gif" />" /><#t />
            </a><#t />
      </#if>
          </span><#t />
      <#if login == sender.foreignKey>
          <a href="#" onclick="return shovel.controller.destroyStatus(${status.statusId});"><#t />
            <img src="<@html.rewrite href="${webroot}/image/trash_i.gif" />" /><#t />
          </a>&nbsp;<#t />
      </#if>
    </#if>
      </td><#lt />
    </tr>
  </#list>
<#else>
    <tr class="nocontent">
      <td colspan="2" class="nocontent">ステータスはありません。</td>
    </tr>
</#if>
  </tbody>
<#assign left>
<a href="<@html.rewrite page="/statuses/user_timeline/${user.userId}.rss" />" style="float: left; padding: 4px 15px; border: 1px solid #cecece;">RSS</a>
</#assign>
<@macro.pager colspan=2 nextPage=nextPage left=left />
</table>
