<#assign bean_el=JspTaglibs["http://struts.apache.org/tags-bean-el"] />
<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#if login?has_content>
<#--ステータスの削除確認-->
<textarea id="template_destroyStatus" style="display: none;">
<@html_escape>
<p>「<span><#noparse>${status}</#noparse></span>」を削除しますか？</p>
<p class="attentionMessage">削除すると取り消しできません。</p>
</@html_escape>
</textarea>
<#--プロフィール画像の削除確認-->
<textarea id="template_destroyPicture" style="display: none;">
<@html_escape>
<p>画像を削除しますか？</p>
<p class="attentionMessage">削除すると取り消しできません。</p>
</@html_escape>
</textarea>
<#--ユーザーの削除確認-->
<textarea id="template_destroyAccounts" style="display: none;">
<@html_escape>
{if userCount > 1}
<p><#noparse>${userCount}</#noparse>件の選択しているユーザを削除しますか？</p>
{else}
<p>「<span><#noparse>${displayName}(${foreignKey})</#noparse></span>」を削除しますか？</p>
{/if}
<p class="attentionMessage">削除すると取り消しできません。</p>
</@html_escape>
</textarea>
<#--Ajaxで発生したエラー-->
<textarea id="template_ajaxError" style="display: none;">
<@html_escape>
<div class="layerBoxContent">
  <h4>通信中にエラーが起こりました。</h4>
  <h3 class="label errorPageLabel">対策:</h3>
  <p class="errorGuide">恐れ入りますが、直前の画面には戻れませんので、<br />下のリンクをクリックして移動してください。</p>
  <p class="errorGuideLink"><a href="<@html.rewrite page="/" />" />ホームへ移動</a></p>
</div>
</@html_escape>
</textarea>
<#--アプリケーションエラー-->
<textarea id="template_applicationError" style="display: none;">
<@html_escape>
      <div style="margin: 1em;">
        <h2 style="margin-bottom: 0.5em;">
          <#noparse>${diagnosis}</#noparse><span class="errorCode">(<#noparse>${errorCode}</#noparse>)</span></p>
        </h2>
        <h3 class="label" style="margin: 3px;"><@bean_el.message key="error.cause"/>:</h3>
        <p class="message" style="margin: 0pt 1.5em;"><#noparse>${cause}</#noparse></p>
        <h3 class="label" style="margin: 3px;"><@bean_el.message key="error.counterMeasure"/>:</h3>
        <p class="message" style="margin: 0pt 1.5em;"><#noparse>${counterMeasure}</#noparse></p>
{if defined('developerInfo')}
        <h3 class="label" style="margin: 3px;"><@bean_el.message key="error.developerInfo"/>:</h3>
        <p class="message" style="margin: 0pt 1.5em;"><#noparse>${developerInfo}</#noparse></p>
        <h3 class="label" style="margin: 3px"><@bean_el.message key="error.stackTrace"/>:</h3>
        <p><#noparse>{for line in stackTrace}${line}<br />{/for}</#noparse></p>
{/if}
       </div>
     </div>
</@html_escape>
</textarea>
<#--遷移せずに保存、変更-->
<textarea id="template_apply" style="display: none;">
<@html_escape>
<span id="notification_apply">反映しました。</span>
</@html_escape>
</textarea>
<#--プロフィール画像あり-->
<#if Application.imagemagick>
<textarea id="template_picture" style="display: none;">
<@html_escape>
{if defined('dummy')}
<img src="<@html.rewrite href="${webroot}/image" />/<#noparse>${size}</#noparse>.gif" style="vertical-align: middle;" /><#rt />
{/if}
<img src="<@html.rewrite page="/${login}" />/-/<#noparse>${size}/${fileName}</#noparse>" title="<#noparse>${displayName}</#noparse>" style="vertical-align: middle; margin-left: -1px;" alt="<#noparse>${fileName}</#noparse>" /><#t />
</@html_escape>
</textarea>
<#else>
<textarea id="template_picture" style="display: none;">
<@html_escape>
{if defined('dummy')}
<img src="<@html.rewrite href="${webroot}/image" />/<#noparse>${size}</#noparse>.gif" style="vertical-align: middle;" /><#rt />
{/if}
<img src="<@html.rewrite page="/${login}" />/-/none/<#noparse>${fileName}</#noparse>" title="<#noparse>${displayName}</#noparse>" style="vertical-align: middle; margin-left: -1px;" alt="<#noparse>${fileName}</#noparse>" width="<#noparse>${width}</#noparse>" height="<#noparse>${height}</#noparse>" /><#t />
</@html_escape>
</textarea>
</#if>
<#--プロフィール画像なし-->
<textarea id="template_noPicture" style="display: none;">
<@html_escape>
<img src="${webroot}/image/nophoto_<#noparse>${size}</#noparse>.gif" />
</@html_escape>
</textarea>
<#--お気に入り外-->
<textarea id="template_unsetFavorite" style="display: none">
<@html_escape>
<a href="#" onclick="return shovel.controller.setFavorite(<#noparse>${statusId}</#noparse>);"><#t />
  <img src="<@html.rewrite href="${webroot}/image/star_empty.gif" />" /><#t />
</a><#t />
</@html_escape>
</textarea>
<#--お気に入り-->
<textarea id="template_setFavorite" style="display: none">
<@html_escape>
<a href="#" onclick="return shovel.controller.unsetFavorite(<#noparse>${statusId}</#noparse>);"><#t />
  <img src="<@html.rewrite href="${webroot}/image/star_full.gif" />" /><#t />
</a><#t />
</@html_escape>
</textarea>
<#--お気に入り処理のスピナー-->
<textarea id="template_settingFavorite" style="display: none">
<@html_escape>
<img src="<@html.rewrite href="${webroot}/image/throbber.gif" />" /><#t />
</@html_escape>
</textarea>
</#if>
<#--寸警告-->
<textarea id="template_flash" style="display: none;">
<@html_escape>
<h2 class="thumb">
  <img src="<@html.rewrite href="${webroot}/image/thumbsup.png" />" />
</h2>
<div class="desc">
  <p><#noparse>${msg}</#noparse></p>
</div>
</@html_escape>
</textarea>
<#--ダイレクトメッセージの削除確認-->
<textarea id="template_destroyDirectMessage" style="display: none;">
<@html_escape>
<p>「<span><#noparse>${text}</#noparse></span>」を削除しますか？</p>
<p class="attentionMessage">削除すると取り消しできません。</p>
</@html_escape>
</textarea>
<#--リソース-->
<textarea id="resources_js" style="display: none;">${jsres}</textarea>
