<#assign bean_el=JspTaglibs["http://struts.apache.org/tags-bean-el"] />
<#assign common=JspTaglibs["/WEB-INF/tld/common.tld"] />
<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#import "/macro.ftl" as macro />
<input type="hidden" name="csrf_ticket" value="${csrf_ticket?default('')}" />
<input type="hidden" name="source" value="web" />
<table class="timeline" cellspacing="0" cellpadding="0">
  <colgroup>
    <col />
    <col />
    <col align="right" width="25px" />
  </colgroup>
  <tbody>
<#if statuses?has_content && statuses?size &gt; 0>
  <#if Session.listRefine.viewType.publicTimeline>
    <tr class="announcement">
      <td colspan="3"><div class="badgebox"><@bean_el.message bundle="message.home" key="publicTimeline.message" /></div></td>
    </tr>
  </#if>
  <#list statuses as status>
    <#assign sender=status.sender />
    <#assign url><@html.rewrite page="/${sender.foreignKey}/statuses/${status.statusId}" /></#assign>
    <tr class="<#if status_has_next>status<#else>last-status</#if>" onmouseover="return shovel.controller.focusStatus(${status.statusId});" onmouseout="return shovel.controller.blurStatus(${status.statusId});">
      <td class="thumb">
        <@macro.icon page="/${sender.foreignKey}" user=sender size="large" />
      </td>
      <td class="desc"><#rt />
        <strong class="enter"><#t />
          <a href="<@html.rewrite page="/${sender.foreignKey}" />" >
            <span title="${sender.displayName}" id="home_foreignKey_${status.statusId}">${sender.foreignKey}</span>
          </a><#t />
    <#if loginUser?has_content && loginUser.userId != sender.userId && sender.protect><img src="<@html.rewrite href="${webroot}/image/lock.png" />" /></#if><#t />
        </strong>&nbsp;<#t />
        <span class="entry-body" id="home_status_${status.statusId}">
          <@common.autoFormat data=status.body url=url />
        </span>&nbsp;<#t />
        <span class="meta"><#t />
          <a href="${url}"><#t />
            <@common.dateFormat date=status.sentTime format="dateTime.compact.variable" /><#t />
          </a><#t />
          &nbsp;from&nbsp;<@macro.sourceWithLink source=status.source dedicatedClient=status.dedicatedClient />&nbsp;<#t />
    <#if status.referenceId &gt; 0>
      <#assign referenceSender=status.referenceSender?default("") />
          <a href="<@html.rewrite page="/${referenceSender.foreignKey}/statuses/${status.referenceId}" />"><#t />
            in reply to ${referenceSender.foreignKey}<#t />
          </a><#t />
    </#if>
        </span><#t />
    <#if status.otherFavorites?has_content>
        <div class="fav" style="float: right;">
          <span class="caption" style="float: left">fav by</span>
      <#list status.otherFavorites as favorite>
        <@macro.icon page="/${favorite.user.foreignKey}" user=favorite.user size="small" /><#t />
        <#if favorite_index == 11>
          <#break>
        </#if>
      </#list>
          <#if status.otherFavorites?size &gt; 12><div class="and-more">...&nbsp;</div></#if>
        </div>
    </#if>
      </td><#lt />
      <td class="actions"><#rt />
        <div id="home_status_action_${status.statusId}" style="height: 40px;"><#t />
    <#if loginUser?has_content>
      <#assign favorite=status.favorite?default("") />
          <div id="home_favorite_${status.statusId}"<#if favorite?has_content> class="favorite"<#else> style="display: none;"</#if>><#t />
      <#if favorite?has_content>
            <a href="#" onclick="return shovel.controller.unsetFavorite(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/star_full.png" />" /><#t />
            </a><#t />
      <#else>
            <a href="#" onclick="return shovel.controller.setFavorite(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/star_empty.png" />" /><#t />
            </a><#t />
      </#if>
          </div><#t />
      <#if loginUser.userId == sender.userId>
          <div id="home_destroyStatus_${status.statusId}" style="display: none;"><#t />
            <a href="#" onclick="return shovel.controller.destroyStatus(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/trash.png" />" /><#t />
            </a><#t />
      <#elseif !Session.listRefine.viewType.favorites>
          <div id="home_replyStatus_${status.statusId}" style="display: none;"><#t />
            <a href="#" onclick="return shovel.controller.replyStatus(${status.statusId});"><#t />
              <img src="<@html.rewrite href="${webroot}/image/reply.png" />" /><#t />
            </a><#t />
      </#if>
          </div>
    <#else>
        &nbsp;<#t />
    </#if>
        </div><#t />
      </td><#lt />
    </tr>
  </#list>
<#else>
    <tr class="nocontent">
      <td colspan="3" class="nocontent"><@bean_el.message bundle="message.home" key="${Session.listRefine.viewType.id}.notUpdated" arg0=user.foreignKey /></td>
    </tr>
</#if>
  </tbody>
<#assign left>
  <#if Session.listRefine.viewType.recent || Session.listRefine.viewType.friendsTimeline>
<a class="rss" href="<@html.rewrite page="/statuses/friends_timeline/${user.userId}.rss" />">RSS</a>
  <#elseif Session.listRefine.viewType.publicTimeline>
<a class="rss" href="<@html.rewrite page="/statuses/public_timeline.rss" />">RSS</a>
  </#if>
</#assign>
<@macro.pager nextPage=nextPage left=left />
</table>
