<#assign bean_el=JspTaglibs["http://struts.apache.org/tags-bean-el"] />
<#assign common=JspTaglibs["/WEB-INF/tld/common.tld"] />
<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#import "/macro.ftl" as macro />
<#if user?has_content>
<form id="sidebar_form">
  <div class="section">
    <div class="section-header-with">
      <h1><@bean_el.message bundle="message.home" key="sidebar.welcome" /></h1>
      <a href="<@html.rewrite page="/${user.foreignKey}" />"><@bean_el.message bundle="message.home" key="sidebar.welcome.profile" /></a>
    </div>
    <div class="account">
<@macro.icon page="/${user.foreignKey}" user=user size="middle" withUsername=true />
    </div>
  </div>
  <div class="section">
    <div class="section-header">
      <h1><@bean_el.message bundle="message.home" key="sidebar.currently" /></h1>
    </div>
    <div id="home_currently">
      <@common.autoFormat data=user.body?default("") maxUrl=25 />
    </div>
  </div>
  <div class="section">
    <div class="section-header-with">
      <h1><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates" /></h1>
<#if device>
      <a href="<@html.rewrite page="/device" />"><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.addDevice" /></a>
<#else>
      <span><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.addDevice" /></span>
</#if>
    </div>
    <div>
<#if !device>
      <@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.wrongSetting" />
<#elseif user.device.availabilityType.inactivation>
      <a href="<@html.rewrite page="/device" />"><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.notSetup" /></a>
<#else>
      <input type="hidden" name="phase" value="" id="sidebar_phase" />
      <input type="radio" name="availability" value="everything" id="sidebar_im"<#if !user.device.availabilityType.off> checked</#if> onchange="shovel.controller.updateDevice();">&nbsp;<label for="sidebar_im"><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.im" /></label><br />
      <input type="radio" name="availability" value="nothing" id="sidebar_web"<#if user.device.availabilityType.off> checked</#if> onchange="shovel.controller.updateDevice();">&nbsp;<label for="sidebar_web"><@bean_el.message bundle="message.home" key="sidebar.deviceUpdates.web" /></label>
</#if>
    </div>
  </div>
  <div class="section">
    <div class="section-header">
      <h1><@bean_el.message bundle="message.home" key="sidebar.stats" /></h1>
    </div>
    <div class="stats">
      <ul>
        <li><span class="column-header"><a href="<@html.rewrite page="/friends" />"><@bean_el.message bundle="message.home" key="sidebar.stats.following" /></a></span><span>${user.friends}</span></li>
        <li><span class="column-header"><a href="<@html.rewrite page="/followers" />"><@bean_el.message bundle="message.home" key="sidebar.stats.follower" /></a></span><span>${user.followers}</span></li>
        <li><span class="column-header"><a href="<@html.rewrite page="/favorites" />"><@bean_el.message bundle="message.home" key="sidebar.stats.favorites" /></a></span><span id="home_favorites">${user.favorites}</span></li>
        <li><span class="column-header"><a href="<@html.rewrite page="/direct_messages" />"><@bean_el.message bundle="message.home" key="sidebar.stats.directMessages" /></a></span><span>${user.directMessages}</span></li>
        <li><span class="column-header"><a href="<@html.rewrite page="/account/archive" />"><@bean_el.message bundle="message.home" key="sidebar.stats.updates" /></a></span><span id="home_statuses">${user.statuses}</span></li>
      </ul>
    </div>
  </div>
  <div class="last-section">
  <#if user.protect>
    <#if user.requests &gt; 0>
    <ul class="notify">
      <li><#rt />
        <a href="<@html.rewrite page="/friend_requests" />"><@bean_el.message bundle="message.home" key="sidebar.following.followRequests" arg0=user.requests?string /></a><#t />
      </li><#lt />
    </ul>
    </#if>
    <div class="friends" style="overflow: hidden;">
  <#else>
    <div class="friends" style="overflow: hidden;">
  </#if>
  <#if friendships?has_content>
      <div>
    <#list friendships as friendship>
      <#assign passive=friendship.passive />
        <span class="friend">
          <@macro.icon page="/${passive.foreignKey}" user=passive size="small" />
        </span>
    </#list>
    <#if viewAllFriends>
        <small class="view-all">
          <a href="<@html.rewrite page="/friends" />"><@bean_el.message bundle="message.home" key="sidebar.following.viewAll" /></a>
        </small>
    </#if>
      </div>
  </#if>
    </div>
  </div>
<#else>
  <div class="last-section">
    <div class="section-header">
      <h1><@bean_el.message bundle="message.home" key="sidebar.introductions" /></h1>
    </div>
  <#if introductions?has_content>
    <ul class="introductions">
    <#list introductions as introduction>
      <li>
        <div class="column-header">
          <@macro.icon page="/${introduction.foreignKey}" user=introduction size="small" withUsername=true />
        </div>
      </li>
    </#list>
    </ul>
  </#if>
  </div>
</#if>
</form>
