<#assign html=JspTaglibs["http://struts.apache.org/tags-html-el"] />
<#import "/macro.ftl" as macro />
<form action="<#if url?has_content>${url}<#else><@html.rewrite page="/system/accounts/update/${user.userId}" /></#if>" enctype="multipart/form-data" method="post" target="fileUpload" id="system_form">
  <input type="hidden" name="csrf_ticket" value="${csrf_ticket}">
  <input type="hidden" name="partial" value="true" />
  <input type="hidden" name="method" value="" id="system_method" />
  <input type="hidden" name="page" value="" id="system_page" />
  <input type="hidden" name="sortOrder" value="" id="system_sortOrder" />
  <input type="hidden" name="iframe" value="true" />
  <input type="hidden" name="userId" value="${user.userId}" />
  <input type="hidden" name="administrator" value="" id="system_administrator" />
  <fieldset class="update">
    <div style="margin: 5px 0pt 10px 0pt; padding: 2px; width: 100%; background-color: #87ceeb; border: 2px solid #00a1d9;"><#rt />
      <a href="#" onclick="return shovel.controller.switchAccounts();">アカウントの一覧</a>&nbsp;&gt;&nbsp;<#t />
      <span>アカウントの<#if create?default(false)>作成<#else>変更</#if></span><#t />
    </div><#lt />
    <table cellspacing="0">
      <tbody>
        <tr>
          <th><label>フルネーム:</label></th>
          <td>
            <input type="text" name="displayName" size="30" value="${user.displayName?default('')}" id="users_displayName" onkeyup="shovel.controller.testSubmit();"><br />
            <small>あなたの本当の名前を入力してください。そうすれば知人があなたを見つけることができます。</small>
          </td>
        </tr>
        <tr>
          <th><label>ユーザー名:</label></th>
          <td>
            <input type="text" name="foreignKey" size="15" maxlength="15" value="${user.foreignKey?default('')}" onkeyup="shovel.controller.conflictForeignKey();" id="users_foreignKey"<#if user.userId = 1> disabled="disabled"</#if> /><br />
            <small>
              あなたのURL: http://${domain}<#if port != 80>:${port}</#if>/<span style="color: green;" id="users_url">${user.foreignKey?default('USERNAME')}</span><br />
              <small id="users_notice">空白は使わないでください。</small><small style="color: green;display: none;" id="users_available">利用できます！</small><small style="color: red;display: none;"" id="users_already">その名前はすでに使われいます。他のものを考えてください。</small><small style="color: red;display: none;"" id="users_invalid">ユーザー名に使えない文字が含まれています。</small>
            </small>
          </td>
        </tr>
        <tr>
          <th><label>メール:</label></th>
          <td><input type="text" name="email" size="30" value="${user.email?default('')}"></td>
        </tr>
        <tr>
          <th><label>タイムゾーン:</label></th>
          <td>
            <select name="timeZoneId">
<#list timeZones as timeZone>
              <option value="${timeZone.ID}"<#if user.timeZoneId?default(defaultTimeZone.ID)==timeZone.ID> selected</#if>>${timeZone.ID}</option>
</#list>
            </select>
          </td>
        </tr>
        <tr>
          <th><label>一行紹介:</label></th>
          <td>
            <input type="text" maxlength="160" name="description" size="30" value="${user.description?default('')}">
            <p><small>160 文字以内で自己紹介してください。</small></p>
          </td>
        </tr>
        <tr>
          <th><label>住所:</label></th>
          <td>
            <input type="text" name="location" size="30" value="${user.location?default('')}">
            <p><small>どこにあなたはいますか？</small></p>
          </td>
        </tr>
        <tr>
          <th></th>
          <td>
            <input type="checkbox" name="protect" value="1" id="users_protect"<#if user.protect> checked="checked"</#if>/><label for="users_protect">更新を保護する</label>
            <p><small>あなたが許可した人にしか更新が見られなくなります。<br />ここにチェックを入れると、<a href="<@html.rewrite page="/public_timeline" />">公開タイムライン</a>には表示されなくなります。</small></p>
          </td>
        </tr>
        <tr>
          <th>管理権限:</th>
          <td>
            <input type="checkbox" value="1" id="users_administrator"<#if user.administrator> checked<#if user.userId &gt; 0 && (user.userId == 1 || (loginUser.foreignKey == user.foreignKey))> disabled</#if></#if>><label for="users_administrator">管理権限を付与する</label>
            <p><small>ここにチェックを入れると、<a href="<@html.rewrite page="/system" />">システム管理</a>にログインできるようになります。</small></p>
          </td>
        </tr>
        <tr>
          <th>
            <label>パスワード:</label>
          </th>
          <td>
            <input type="password" autocomplete="off" name="password" id="users_password" value="${user.password?default("")}" />
          </td>
        </tr>
        <tr>
          <th>
            <label>パスワード（確認）:</label>
          </th>
          <td>
            <input type="password" autocomplete="off" name="confirmation" id="users_confirmation" value="${user.password?default("")}" />
            <br><small id="password_mismatch" style="display: none;">Passwords don't match</small>
          </td>
        </tr>
        <tr>
          <th><label>アイコン:</label></th>
          <td>
            <table>
              <tbody>
                <@macro.imageUploader user=user idPrefix="users" maxSize=maxSize />
              </tbody>
            </table>
          </td>
        </tr>
        <tr>
          <th></th>
          <td><input type="submit" value="<#if create?default(false)>保存する<#else>更新する</#if>" <#if user.userId == 0> disabled="disabled"</#if> id="users_submit" onclick="shovel.controller.updateAccount();" /></td>
        </tr>
      </tbody>
    </table>
  </fieldset>
</form>
